diff -u -r gis-orig/admin/options.py gis/admin/options.py
--- gis-orig/admin/options.py	2010-09-24 14:24:21.000000000 -0400
+++ gis/admin/options.py	2010-09-24 15:16:00.431318898 -0400
@@ -67,12 +67,28 @@
         in the `widget` attribute) using the settings from the attributes set
         in this class.
         """
-        is_collection = db_field.geom_type in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION')
-        if is_collection:
-            if db_field.geom_type == 'GEOMETRYCOLLECTION': collection_type = 'Any'
-            else: collection_type = OGRGeomType(db_field.geom_type.replace('MULTI', ''))
+
+        is_unknown = db_field.geom_type in ('GEOMETRY',)
+        if not is_unknown:
+            #If it is not generic, get the parameters from the db_field
+            is_collection = db_field.geom_type in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION')
+            if is_collection:
+                if db_field.geom_type == 'GEOMETRYCOLLECTION': collection_type = 'Any'
+                else: collection_type = OGRGeomType(db_field.geom_type.upper().replace('MULTI', ''))
+            else:
+                collection_type = 'None'
+            is_linestring = db_field.geom_type in ('LINESTRING', 'MULTILINESTRING')
+            is_polygon = db_field.geom_type in ('POLYGON', 'MULTIPOLYGON')
+            is_point = db_field.geom_type in ('POINT', 'MULTIPOINT')
+            geom_type = OGRGeomType(db_field.geom_type)
         else:
+            #If it is generic, set sensible defaults
+            is_collection = False
             collection_type = 'None'
+            is_linestring = False
+            is_polygon = False
+            is_point = False
+            geom_type = OGRGeomType('Unknown')
 
         class OLMap(self.widget):
             template = self.map_template
@@ -81,15 +97,16 @@
                       'default_lat' : self.default_lat,
                       'default_zoom' : self.default_zoom,
                       'display_wkt' : self.debug or self.display_wkt,
-                      'geom_type' : OGRGeomType(db_field.geom_type),
+                      'geom_type' : geom_type,
                       'field_name' : db_field.name,
+                      'is_unknown': is_unknown,
                       'is_collection' : is_collection,
                       'scrollable' : self.scrollable,
                       'layerswitcher' : self.layerswitcher,
                       'collection_type' : collection_type,
-                      'is_linestring' : db_field.geom_type in ('LINESTRING', 'MULTILINESTRING'),
-                      'is_polygon' : db_field.geom_type in ('POLYGON', 'MULTIPOLYGON'),
-                      'is_point' : db_field.geom_type in ('POINT', 'MULTIPOINT'),
+                      'is_linestring' : is_linestring,
+                      'is_polygon' : is_polygon,
+                      'is_point' : is_point,
                       'num_zoom' : self.num_zoom,
                       'max_zoom' : self.max_zoom,
                       'min_zoom' : self.min_zoom,
diff -u -r gis-orig/admin/widgets.py gis/admin/widgets.py
--- gis-orig/admin/widgets.py	2010-09-24 14:24:21.000000000 -0400
+++ gis/admin/widgets.py	2010-09-24 15:21:53.933461558 -0400
@@ -4,6 +4,7 @@
 from django.forms.widgets import Textarea
 from django.template import loader, Context
 from django.utils import translation
+from django.contrib.gis.gdal import OGRGeomType
 
 # Creating a template context that contains Django settings
 # values needed by admin map templates.
@@ -31,8 +32,7 @@
                 value = GEOSGeometry(value)
             except (GEOSException, ValueError):
                 value = None
-
-        if value and value.geom_type.upper() != self.geom_type:
+        if value and value.geom_type.upper() != self.geom_type and self.geom_type != 'GEOMETRY':
             value = None
 
         # Constructing the dictionary of the map options.
@@ -65,6 +65,29 @@
             # geometry.
             self.params['wkt'] = wkt
 
+            # Check if the field is generic so the proper values are overriden
+            if self.params['is_unknown']:
+                self.params['geom_type'] = OGRGeomType(value.geom_type)
+                if value.geom_type.upper() in ('LINESTRING', 'MULTILINESTRING'):
+                    self.params['is_linestring'] = True
+                elif value.geom_type.upper() in ('POLYGON', 'MULTIPOLYGON'):
+                    self.params['is_polygon'] = True
+                elif value.geom_type.upper() in ('POINT', 'MULTIPOINT'):
+                    self.params['is_point'] = True
+                if value.geom_type.upper() in ('MULTIPOINT', 'MULTILINESTRING', 'MULTIPOLYGON', 'GEOMETRYCOLLECTION'):
+                    self.params['is_collection']=True
+                    if value.geom_type.upper() == 'GEOMETRYCOLLECTION':
+                        self.params['collection_type'] = 'Any'
+                    else:
+                        self.params['collection_type'] = OGRGeomType(value.geom_type.upper().replace('MULTI', ''))
+
+        else:
+            if self.params['is_unknown']:
+                # If the geometry is unknown and the value is not set, make it as flexible as possible.
+                self.params['geom_type'] = OGRGeomType('GEOMETRYCOLLECTION')
+                self.params['is_collection']=True
+                self.params['collection_type'] = 'Any'
+
         return loader.render_to_string(self.template, self.params,
                                        context_instance=geo_context)
 
diff -u -r gis-orig/templates/gis/admin/openlayers.js gis/templates/gis/admin/openlayers.js
--- gis-orig/templates/gis/admin/openlayers.js	2010-09-24 14:24:21.000000000 -0400
+++ gis/templates/gis/admin/openlayers.js	2010-09-24 15:40:43.691209474 -0400
@@ -1,3 +1,5 @@
+// Overrides for Openblock: support multipolygon and multipoint.
+// TODO: submit upstream patch at http://code.djangoproject.com/ticket/9806
 {# Author: Justin Bronn, Travis Pinney & Dane Springmeyer #}
 {% block vars %}var {{ module }} = {};
 {{ module }}.map = null; {{ module }}.controls = null; {{ module }}.panel = null; {{ module }}.re = new RegExp("^SRID=\d+;(.+)", "i"); {{ module }}.layers = {};
@@ -9,19 +11,19 @@
 {{ module }}.is_polygon = {{ is_polygon|yesno:"true,false" }};
 {{ module }}.is_point = {{ is_point|yesno:"true,false" }};
 {% endblock %}
-{{ module }}.get_ewkt = function(feat){return 'SRID={{ srid }};' + {{ module }}.wkt_f.write(feat);}
+{{ module }}.get_ewkt = function(feat){return 'SRID={{ srid }};' + {{ module }}.wkt_f.write(feat);};
 {{ module }}.read_wkt = function(wkt){
   // OpenLayers cannot handle EWKT -- we make sure to strip it out.
   // EWKT is only exposed to OL if there's a validation error in the admin.
   var match = {{ module }}.re.exec(wkt);
   if (match){wkt = match[1];}
   return {{ module }}.wkt_f.read(wkt);
-}
+};
 {{ module }}.write_wkt = function(feat){
   if ({{ module }}.is_collection){ {{ module }}.num_geom = feat.geometry.components.length;}
   else { {{ module }}.num_geom = 1;}
   document.getElementById('{{ id }}').value = {{ module }}.get_ewkt(feat);
-}
+};
 {{ module }}.add_wkt = function(event){
   // This function will sync the contents of the `vector` layer with the
   // WKT in the text field.
@@ -40,7 +42,7 @@
     }
     {{ module }}.write_wkt(event.feature);
   }
-}
+};
 {{ module }}.modify_wkt = function(event){
   if ({{ module }}.is_collection){
     if ({{ module }}.is_point){
@@ -58,7 +60,7 @@
   } else {
     {{ module }}.write_wkt(event.feature);
   }
-}
+};
 // Function to clear vector features and purge wkt from div
 {{ module }}.deleteFeatures = function(){
   {{ module }}.layers.vector.removeFeatures({{ module }}.layers.vector.features);
@@ -68,15 +70,15 @@
   {{ module }}.deleteFeatures();
   document.getElementById('{{ id }}').value = '';
   {{ module }}.map.setCenter(new OpenLayers.LonLat({{ default_lon }}, {{ default_lat }}), {{ default_zoom }});
-}
+};
 // Add Select control
 {{ module }}.addSelectControl = function(){
   var select = new OpenLayers.Control.SelectFeature({{ module }}.layers.vector, {'toggle' : true, 'clickout' : true});
   {{ module }}.map.addControl(select);
   select.activate();
-}
-{{ module }}.enableDrawing = function(){ {{ module }}.map.getControlsByClass('OpenLayers.Control.DrawFeature')[0].activate();}
-{{ module }}.enableEditing = function(){ {{ module }}.map.getControlsByClass('OpenLayers.Control.ModifyFeature')[0].activate();}
+};
+{{ module }}.enableDrawing = function(){ {{ module }}.map.getControlsByClass('OpenLayers.Control.DrawFeature')[0].activate();};
+{{ module }}.enableEditing = function(){ {{ module }}.map.getControlsByClass('OpenLayers.Control.ModifyFeature')[0].activate();};
 // Create an array of controls based on geometry type
 {{ module }}.getControls = function(lyr){
   {{ module }}.panel = new OpenLayers.Control.Panel({'displayClass': 'olControlEditingToolbar'});
@@ -88,18 +90,24 @@
     draw_ctl = new OpenLayers.Control.DrawFeature(lyr, OpenLayers.Handler.Polygon, {'displayClass': 'olControlDrawFeaturePolygon'});
   } else if ({{ module }}.is_point){
     draw_ctl = new OpenLayers.Control.DrawFeature(lyr, OpenLayers.Handler.Point, {'displayClass': 'olControlDrawFeaturePoint'});
-  }
-  if ({{ module }}.modifiable){
-    var mod = new OpenLayers.Control.ModifyFeature(lyr, {'displayClass': 'olControlModifyFeature'});
-    {{ module }}.controls = [nav, draw_ctl, mod];
-  } else {
-    if(!lyr.features.length){
-      {{ module }}.controls = [nav, draw_ctl];
+  };
+  // TODO: draw_ctl is undefined if is_collection==true and collection_type=='Any'. Don't know what handler to use then.
+  if (draw_ctl != undefined) {
+    if ({{module}}.is_collection )  {
+      draw_ctl.multi = true;
+    };
+    if ({{ module }}.modifiable){
+      var mod = new OpenLayers.Control.ModifyFeature(lyr, {'displayClass': 'olControlModifyFeature'});
+      {{ module }}.controls = [nav, draw_ctl, mod];
     } else {
-      {{ module }}.controls = [nav];
+      if(!lyr.features.length){
+        {{ module }}.controls = [nav, draw_ctl];
+      } else {
+        {{ module }}.controls = [nav];
+      }
     }
   }
-}
+};
 {{ module }}.init = function(){
     {% block map_options %}// The options hash, w/ zoom, resolution, and projection settings.
     var options = {
@@ -164,4 +172,4 @@
     } else {
       {{ module }}.enableDrawing();
     }
-}
+};