Index: django/contrib/admin/util.py
===================================================================
--- django/contrib/admin/util.py	(revisjon 9646)
+++ django/contrib/admin/util.py	(arbeidskopi)
@@ -104,7 +104,7 @@
                 if not has_admin:
                     # Don't display link to edit, because it either has no
                     # admin or is edited inline.
-                    nh(deleted_objects, current_depth, [u'%s: %s' % (force_unicode(capfirst(related.opts.verbose_name)), sub_obj), []])
+                    nh(deleted_objects, current_depth, [u'%s: %s' % (capfirst(related.opts.verbose_name), force_unicode(sub_obj)), []])
                 else:
                     # Display a link to the admin page.
                     nh(deleted_objects, current_depth, [mark_safe(u'%s: <a href="../../../../%s/%s/%s/">%s</a>' % \
Index: tests/regressiontests/admin_views/fixtures/admin-views-unicode.xml
===================================================================
--- tests/regressiontests/admin_views/fixtures/admin-views-unicode.xml	(revisjon 0)
+++ tests/regressiontests/admin_views/fixtures/admin-views-unicode.xml	(revisjon 0)
@@ -0,0 +1,35 @@
+<?xml version="1.0" encoding="utf-8"?>
+<django-objects version="1.0">
+    <object pk="100" model="auth.user">
+        <field type="CharField" name="username">super</field>
+        <field type="CharField" name="first_name">Super</field>
+        <field type="CharField" name="last_name">User</field>
+        <field type="CharField" name="email">super@example.com</field>
+        <field type="CharField" name="password">sha1$995a3$6011485ea3834267d719b4c801409b8b1ddd0158</field>
+        <field type="BooleanField" name="is_staff">True</field>
+        <field type="BooleanField" name="is_active">True</field>
+        <field type="BooleanField" name="is_superuser">True</field>
+        <field type="DateTimeField" name="last_login">2007-05-30 13:20:10</field>
+        <field type="DateTimeField" name="date_joined">2007-05-30 13:20:10</field>
+        <field to="auth.group" name="groups" rel="ManyToManyRel"></field>
+        <field to="auth.permission" name="user_permissions" rel="ManyToManyRel"></field>
+    </object>
+    <object pk="1" model="admin_views.book">
+        <field type="CharField" name="name">Lærdommer</field>
+    </object>
+    <object pk="1" model="admin_views.chapter">
+        <field type="CharField" name="title">Norske bostaver æøå skaper problemer</field>
+        <field type="TextField" name="content">&lt;p&gt;Svært frustrerende med UnicodeDecodeErro&lt;/p&gt;</field>
+        <field to="admin_views.book" name="book" rel="ManyToOneRel">1</field>
+    </object>
+    <object pk="2" model="admin_views.chapter">
+        <field type="CharField" name="title">Kjærlighet</field>
+        <field type="TextField" name="content">&lt;p&gt;La kjærligheten til de lidende seire.&lt;/p&gt;</field>
+        <field to="admin_views.book" name="book" rel="ManyToOneRel">1</field>
+    </object>
+    <object pk="3" model="admin_views.chapter">
+        <field type="CharField" name="title">Kjærlighet</field>
+        <field type="TextField" name="content">&lt;p&gt;Noe innhold&lt;/p&gt;</field>
+        <field to="admin_views.book" name="book" rel="ManyToOneRel">1</field>
+    </object>
+</django-objects>
Index: tests/regressiontests/admin_views/tests.py
===================================================================
--- tests/regressiontests/admin_views/tests.py	(revisjon 9646)
+++ tests/regressiontests/admin_views/tests.py	(arbeidskopi)
@@ -684,3 +684,54 @@
         self.client.post('/test_admin/admin/secure-view/', self.super_login)
         # make sure the view removes test cookie
         self.failUnlessEqual(self.client.session.test_cookie_worked(), False)
+
+class AdminViewUnicodeTest(TestCase):
+    fixtures = ['admin-views-unicode.xml']
+
+    def setUp(self):
+        self.client.login(username='super', password='secret')
+
+    def tearDown(self):
+        self.client.logout()
+
+    def testUnicodeEdit(self):
+        """
+        A test to ensure that POST on edit_view handles non-ascii characters.
+        """
+        post_data = {
+            "name": u"Test lærdommer",
+            # inline data
+            "chapter_set-TOTAL_FORMS": u"6",
+            "chapter_set-INITIAL_FORMS": u"3",
+            "chapter_set-0-id": u"1",
+            "chapter_set-0-title": u"Norske bostaver æøå skaper problemer",
+            "chapter_set-0-content": u"&lt;p&gt;Svært frustrerende med UnicodeDecodeError&lt;/p&gt;",
+            "chapter_set-1-id": u"2",
+            "chapter_set-1-title": u"Kjærlighet.",
+            "chapter_set-1-content": u"&lt;p&gt;La kjærligheten til de lidende seire.&lt;/p&gt;",
+            "chapter_set-2-id": u"3",
+            "chapter_set-2-title": u"Need a title.",
+            "chapter_set-2-content": u"&lt;p&gt;Newest content&lt;/p&gt;",
+            "chapter_set-3-id": u"",
+            "chapter_set-3-title": u"",
+            "chapter_set-3-content": u"",
+            "chapter_set-4-id": u"",
+            "chapter_set-4-title": u"",
+            "chapter_set-4-content": u"",
+            "chapter_set-5-id": u"",
+            "chapter_set-5-title": u"",
+            "chapter_set-5-content": u"",
+        }
+
+        response = self.client.post('/test_admin/admin/admin_views/book/1/', post_data)
+        self.failUnlessEqual(response.status_code, 302) # redirect somewhere
+
+    def testUnicodeDelete(self):
+        """
+        Ensure that the delete_view handles non-ascii characters
+        """
+        delete_dict = {'post': 'yes'}
+        response = self.client.get('/test_admin/admin/admin_views/book/1/delete/')
+        self.failUnlessEqual(response.status_code, 200)
+        response = self.client.post('/test_admin/admin/admin_views/book/1/delete/', delete_dict)
+        self.assertRedirects(response, '/test_admin/admin/admin_views/book/')
Index: tests/regressiontests/admin_views/models.py
===================================================================
--- tests/regressiontests/admin_views/models.py	(revisjon 9646)
+++ tests/regressiontests/admin_views/models.py	(arbeidskopi)
@@ -24,6 +24,20 @@
         return self.date.year
     model_year.admin_order_field = 'date'
 
+class Book(models.Model):
+    """
+    A simple book that has chapters.
+    """
+    name = models.CharField(max_length=100)
+
+class Chapter(models.Model):
+    title = models.CharField(max_length=100)
+    content = models.TextField()
+    book = models.ForeignKey(Book)
+
+    def __unicode__(self):
+        return self.title
+
 def callable_year(dt_value):
     return dt_value.year
 callable_year.admin_order_field = 'date'
@@ -31,6 +45,9 @@
 class ArticleInline(admin.TabularInline):
     model = Article
 
+class ChapterInline(admin.TabularInline):
+    model = Chapter
+
 class ArticleAdmin(admin.ModelAdmin):
     list_display = ('content', 'date', callable_year, 'model_year', 'modeladmin_year')
     list_filter = ('date',)
@@ -92,6 +109,7 @@
 admin.site.register(Article, ArticleAdmin)
 admin.site.register(CustomArticle, CustomArticleAdmin)
 admin.site.register(Section, inlines=[ArticleInline])
+admin.site.register(Book, inlines=[ChapterInline])
 admin.site.register(ModelWithStringPrimaryKey)
 admin.site.register(Color)
 admin.site.register(Thing, ThingAdmin)