diff --git a/django/contrib/auth/views.py b/django/contrib/auth/views.py
index e1f0d43..ceb9cfc 100644
--- a/django/contrib/auth/views.py
+++ b/django/contrib/auth/views.py
@@ -14,8 +14,19 @@ from django.utils.translation import ugettext as _
 from django.contrib.auth.models import User
 from django.views.decorators.cache import never_cache
 
-def login(request, template_name='registration/login.html', redirect_field_name=REDIRECT_FIELD_NAME):
+def expand_callables(dictionary):
+    result = {}
+    for key, value in dictionary.items():
+        if callable(value):
+            result[key] = value()
+        else:
+            result[key] = value
+    return result
+
+def login(request, template_name='registration/login.html', extra_context=None,
+        redirect_field_name=REDIRECT_FIELD_NAME):
     "Displays the login form and handles the login action."
+    if extra_context is None: extra_context = {}
     redirect_to = request.REQUEST.get(redirect_field_name, '')
     if request.method == "POST":
         form = AuthenticationForm(data=request.POST)
@@ -35,19 +46,22 @@ def login(request, template_name='registration/login.html', redirect_field_name=
         current_site = Site.objects.get_current()
     else:
         current_site = RequestSite(request)
-    return render_to_response(template_name, {
-        'form': form,
-        redirect_field_name: redirect_to,
-        'site_name': current_site.name,
-    }, context_instance=RequestContext(request))
+    context = {'form': form,
+        redirect_field_name: redirect_to, 'site_name': current_site.name}
+    context.update(expand_callables(extra_context))
+    return render_to_response(template_name, context, context_instance=RequestContext(request))
 login = never_cache(login)
 
-def logout(request, next_page=None, template_name='registration/logged_out.html'):
+def logout(request, next_page=None, 
+        template_name='registration/logged_out.html', extra_context=None):
     "Logs out the user and displays 'You are logged out' message."
+    if extra_context is None: extra_context = {}
     from django.contrib.auth import logout
     logout(request)
     if next_page is None:
-        return render_to_response(template_name, {'title': _('Logged out')}, context_instance=RequestContext(request))
+        context = {'title': _('Logged out')}
+        context.update(expand_callables(extra_context))
+        return render_to_response(template_name, context, context_instance=RequestContext(request))
     else:
         # Redirect to this page until the session has been cleared.
         return HttpResponseRedirect(next_page or request.path)
@@ -74,9 +88,11 @@ def redirect_to_login(next, login_url=None, redirect_field_name=REDIRECT_FIELD_N
 def password_reset(request, is_admin_site=False, template_name='registration/password_reset_form.html',
         email_template_name='registration/password_reset_email.html',
         password_reset_form=PasswordResetForm, token_generator=default_token_generator,
-        post_reset_redirect=None):
+        post_reset_redirect=None, extra_context=None):
     if post_reset_redirect is None:
         post_reset_redirect = reverse('django.contrib.auth.views.password_reset_done')
+    if extra_context is None:
+        extra_context = {}
     if request.method == "POST":
         form = password_reset_form(request.POST)
         if form.is_valid():
@@ -93,16 +109,22 @@ def password_reset(request, is_admin_site=False, template_name='registration/pas
             return HttpResponseRedirect(post_reset_redirect)
     else:
         form = password_reset_form()
-    return render_to_response(template_name, {
-        'form': form,
-    }, context_instance=RequestContext(request))
+    context = {'form': form}
+    context.update(expand_callables(extra_context)) 
+    return render_to_response(template_name, 
+        context, context_instance=RequestContext(request))
 
-def password_reset_done(request, template_name='registration/password_reset_done.html'):
-    return render_to_response(template_name, context_instance=RequestContext(request))
+def password_reset_done(request, 
+        template_name='registration/password_reset_done.html', extra_context=None):
+    if extra_context is None:
+        context = {}
+    else:
+        context = expand_callables(extra_context)
+    return render_to_response(template_name, context, context_instance=RequestContext(request))
 
 def password_reset_confirm(request, uidb36=None, token=None, template_name='registration/password_reset_confirm.html',
                            token_generator=default_token_generator, set_password_form=SetPasswordForm,
-                           post_reset_redirect=None):
+                           post_reset_redirect=None, extra_context=None):
     """
     View that checks the hash in a password reset link and presents a
     form for entering a new password.
@@ -110,6 +132,8 @@ def password_reset_confirm(request, uidb36=None, token=None, template_name='regi
     assert uidb36 is not None and token is not None # checked by URLconf
     if post_reset_redirect is None:
         post_reset_redirect = reverse('django.contrib.auth.views.password_reset_complete')
+    if extra_context is None:
+        extra_context = {}
     try:
         uid_int = base36_to_int(uidb36)
     except ValueError:
@@ -130,17 +154,22 @@ def password_reset_confirm(request, uidb36=None, token=None, template_name='regi
     else:
         context_instance['validlink'] = False
         form = None
-    context_instance['form'] = form    
-    return render_to_response(template_name, context_instance=context_instance)
+    context = {'form': form}
+    context.update(expand_callables(extra_context))    
+    return render_to_response(template_name, context, context_instance=context_instance)
 
-def password_reset_complete(request, template_name='registration/password_reset_complete.html'):
-    return render_to_response(template_name, context_instance=RequestContext(request,
-                                                                             {'login_url': settings.LOGIN_URL}))
+def password_reset_complete(request, 
+        template_name='registration/password_reset_complete.html', extra_context=None):
+    if extra_context is None: extra_context = {}
+    context = {'login_url': settings.LOGIN_URL}
+    context.update(expand_callables(extra_context))
+    return render_to_response(template_name, context, context_instance=RequestContext(request))
 
 def password_change(request, template_name='registration/password_change_form.html',
-                    post_change_redirect=None):
+                    post_change_redirect=None, extra_context=None):
     if post_change_redirect is None:
         post_change_redirect = reverse('django.contrib.auth.views.password_change_done')
+    if extra_context is None: extra_context = {}
     if request.method == "POST":
         form = PasswordChangeForm(request.user, request.POST)
         if form.is_valid():
@@ -148,10 +177,15 @@ def password_change(request, template_name='registration/password_change_form.ht
             return HttpResponseRedirect(post_change_redirect)
     else:
         form = PasswordChangeForm(request.user)
-    return render_to_response(template_name, {
-        'form': form,
-    }, context_instance=RequestContext(request))
+    context = {'form': form}
+    context.update(expand_callables(extra_context))
+    return render_to_response(template_name, context, context_instance=RequestContext(request))
 password_change = login_required(password_change)
 
-def password_change_done(request, template_name='registration/password_change_done.html'):
-    return render_to_response(template_name, context_instance=RequestContext(request))
+def password_change_done(request, template_name='registration/password_change_done.html',
+                         extra_context=None):
+    if extra_context is None:
+        context = {}
+    else:
+        context = expand_callables(extra_context)
+    return render_to_response(template_name, context, context_instance=RequestContext(request))